#include "filescan.h"

void iftrue(void);
void iffalse(void);
void errormsg(void);
int c_break(void);

struct time t;

void main(int argc, char *argv[])
{  char achar; int loop, EXITNOW=1, CHECKKEY=0, CHECKLOOP=0;
   div_t x;
   int break_flag;

  _setcursortype(_NOCURSOR);
  clrscr();
  ctrlbrk(c_break);
  if (argc == 1)
	DELAYTIME = 10;
  else
	{  if (argc == 4)
		 {  START = atoi(argv[1]);
			STOP = atoi(argv[2]);
			DELAYTIME = atoi(argv[3]);
		 } // if
	   else
		 errormsg();
	} // else
  strcpy(filename,argv[1]);
  initmainnwcalls();
  initnwcalls();
  getconninfo(connNumber);
  servercount = scanforservers();
  for (loop=0;loop<=servercount;loop++)
	serversattached = getserverinfo(loop);
  outputinfo();
  clrscr();
  do
  {  while (!kbhit())
	 {  gettime(&t);
		if ((t.ti_hour >= START) && (t.ti_hour < STOP))
		{  x = div(t.ti_min,DELAYTIME);
		   if ((x.rem == 0) && (t.ti_sec == 0))
			 iftrue();
		   else
			 iffalse();
		} // if
		else
		  iffalse();
		sleep(1);
	 } // while
	 achar = getch();
	 achar = toupper(achar);
	 CHECKLOOP =0;
	 while (CHECKLOOP == 0)
	 { switch (achar)
	   {  //case 0: printf("YES");break;
//		  case 32: CHECKLOOP = 1; EXITNOW = 1; break;
		  case 80: if (CHECKKEY == 0 || CHECKKEY == 2)  CHECKKEY++; break;
		  case 69: if (CHECKKEY == 1)  CHECKKEY++; break;
		  case 83: if (CHECKKEY == 3)  CHECKKEY++; break;
		  case 73: if (CHECKKEY == 4)  CHECKKEY++; break;
		  default: CHECKLOOP = 1; break;
	   } // switch
	   achar = getch();
	   achar = toupper(achar);
	 }
	 if (CHECKKEY == 5)
	   EXITNOW = 1;
	 else
	   {  CHECKKEY = 0;
		  EXITNOW = 0;
	   }
	} //do
  while (EXITNOW == 0);
  _setcursortype(_NORMALCURSOR);
  sound(100);
  sleep(1);
  nosound();
  clrscr();
  printf("\nNow that I have your attention. . .");
  printf("\nRemember to restart this utility you just exited.");
  printf("\nGoto SPOCK\\DATA:HOME\\RAJN and execute FILES.BAT");
  printf("\nThank you.");
  printf("\n\nWhat the utility does:");
  printf("\n--Scans for open files every 10 minutes from 6am to 6pm.");
  printf("\n--Copies certain directories (user data) from SPOCK to DATA at 10pm");
} //main

// if true. . .can add other items like backups, virus scans. . .
void iftrue()
{  outputinfo();
   clrscr();
} // iftrue

// if false . . . add other info later
void iffalse()
{  FILE *backup;

   gotoxy(1,1);
   gettime(&t);
   printf("\nCurrent time: %02d:%02d:%02d",t.ti_hour,t.ti_min,t.ti_sec);
   printf("\nStart time: %2d:00",START);
   printf("\nStop time:  %2d:00",STOP);
   printf("\nScan interval: %d minutes",DELAYTIME);
   printf("\n\nTo exit, hit the space bar.");
   printf("\nExecute FILES at H:\\");
   if ((t.ti_hour == 22) && (t.ti_min == 0))
	 {
	   backup = fopen("c:\\backup.bat","w");
	   fprintf(backup,"\nmap p:=spock\\sys:");
	   fprintf(backup,"\nmap q:=data\\sys:");
	   fprintf(backup,"\nncopy p:\\apps\\*.* q:\\apps /s");
	   fprintf(backup,"\nmap p:=spock\\data:");
	   fprintf(backup,"\nmap q:=data\\data:");
	   fprintf(backup,"\nncopy p:\\home\\*.* q:\\home /s");
	   fprintf(backup,"\nncopy p:\\dpu\\*.* q:\\dpu /s");
	   fprintf(backup,"\nncopy p:\\maint\\*.* q:\\maint /s");
	   fprintf(backup,"\nncopy p:\\home\\*.* q:\\home /s");
	   fprintf(backup,"\nncopy p:\\lab\\*.* q:\\lab /s");
	   fprintf(backup,"\nncopy p:\\admin\\*.* q:\\admin /s");
	   fprintf(backup,"\nncopy p:\\clerical\\*.* q:\\clerical /s");
	   fprintf(backup,"\nncopy p:\\ess\\*.* q:\\ess /s");
	   fprintf(backup,"\nncopy p:\\ops\\*.* q:\\ops /s");
	   fprintf(backup,"\nh:");
	   fprintf(backup,"\ncd\\");
//	   fprintf(backup,"\ndel c:\\backup.bat");
	   fprintf(backup,"\nfiles");
	   fclose(backup);
	   exit(1);
	 } // if
} // iffalse

// print the error for invalid number of parameters and syntax
void errormsg()
{ clrscr();
  printf("\nFILESCAN.EXE: Scans for open files.\n");
  printf("\nSyntax: filescan [START STOP DELAYTIME]");
  printf("\nSTART/STOP - times to start and stop the scan -- 24 hour format");
  printf("\nDELAYTIME - delay between scans.  Values are 1 - 60");
  printf("\n\nIf parameters are not entered, defaults are 6 18 10.");
  printf("\nWhich means, it will scan from 6am to 6pm, at 10 minute intervals.");
  printf("\nIf you wanted to scan every 4 minutes from 5am to 11pm, values = 5 23 4.");
  _setcursortype(_NORMALCURSOR);
  exit(1);
} // errormsg

//get connection information based on connection number and connhandle
int getconninfo(int cnum)
{  WORD nwrc;

	nwrc = NWGetConnectionInformation(connHandle, cnum, (char FAR *)objname, (WORD FAR *)&objtype, (DWORD FAR *)&objID,
												(BYTE FAR *)logintime);
	objID = NWLongSwap(objID);
	if (nwrc != 0x0000)
	  {  //printf("\nNWGetConnectionInformation failed: %04x",nwrc);
		   return(1);
	  }

  return(0);
} //getconninfo


//scan the bindery for other servers
int scanforservers()
 {  int binerror = 0, counter=0;
	 WORD nwrc;
	 char searchName[48], objectName[48];
	 NWOBJ_TYPE searchType = OT_FILE_SERVER, objectType;
	 NWOBJ_ID objectID = -1;
	 NWFLAGS hasPropertiesFlag, objectFlags, objectSecurity;

	strcpy(searchName,"*");
	while (binerror == 0)
	 {
		nwrc = (NWScanObject(connHandle, (char NWFAR *)searchName, searchType, (NWOBJ_ID NWFAR *)&objectID,
			(char NWFAR *)&objectName, (NWOBJ_TYPE NWFAR *)&objectType, (NWFLAGS NWFAR *)&hasPropertiesFlag,
			(NWFLAGS NWFAR *)&objectFlags, (NWFLAGS NWFAR *)&objectSecurity));
		if (nwrc != 0x0000)
		  {  //printf("\nNWScanObject failed: %x",nwrc);
			  binerror = 1;   //getch(); exit(1);
			}
		else
		  {  binerror = 0;
		     strcpy(serverlist[counter].name,objectName);
		     counter++;
		  }
	  }
	 objectID = NWLongSwap(objectID);
	 return(counter);
} //scanforservers

//Get a list of users on the current server
void getuserlist(int snum)
{ int loop, result=0, counter=0;
  WORD nwrc;

	printf("\n");
	fprintf(datafile,"\n");
	for (loop=1;loop<=fsinfo.maximumServiceConnections;loop++)
	  {  result = getconninfo(loop);
		  if (result == 0)
			 {  nwrc = (NWGetInetAddr(connHandle, loop,(NWINET_ADDR NWFAR *)&inetAddr));
				 if (nwrc != 0x0000)
					{  printf("\nNWGetInetAddr: failed %04x",nwrc);
						exit(1);
					}
				 printf("\n%2d. %-8s\t[%08lX] %02d/%02d/%02d @ %02d:%02d:%02d from %X%X%X%X:%X%X%X%X%X%X",loop,objname,objID,
				 (int)logintime[1], (int)logintime[2],(int)logintime[0],(int)logintime[3],(int)logintime[4],(int)logintime[5],
				 inetAddr.networkAddr[0],inetAddr.networkAddr[1],inetAddr.networkAddr[2],inetAddr.networkAddr[3],
				 inetAddr.netNodeAddr[0],inetAddr.netNodeAddr[1],inetAddr.netNodeAddr[2],
				 inetAddr.netNodeAddr[3],inetAddr.netNodeAddr[4],inetAddr.netNodeAddr[5]);

				 fprintf(datafile,"\n%2d. %-8s\t[%08lX] %02d/%02d/%02d @ %02d:%02d:%02d from %X%X%X%X:%X%X%X%X%X%X",loop,objname,objID,
				 (int)logintime[1], (int)logintime[2],(int)logintime[0],(int)logintime[3],(int)logintime[4],(int)logintime[5],
				 inetAddr.networkAddr[0],inetAddr.networkAddr[1],inetAddr.networkAddr[2],inetAddr.networkAddr[3],
				 inetAddr.netNodeAddr[0],inetAddr.netNodeAddr[1],inetAddr.netNodeAddr[2],
				 inetAddr.netNodeAddr[3],inetAddr.netNodeAddr[4],inetAddr.netNodeAddr[5]);

				 counter++;
				 scanforfiles(loop);
			 }
	  }
	printf("\n%d users on %-5s",counter,serverinfo[snum].name);
	fprintf(datafile,"\n%2d users on %-5s",counter,serverinfo[snum].name);
	fprintf(datafile2,"\n%2d users on %-5s",counter,serverinfo[snum].name);

} // getuserlist

//scan the connection for open files
void scanforfiles(theconn)
{  WORD nwrc;
	NWLAST_RECORD lastRecord = 0;
	OPEN_FILE_CONN_CTRL openCtrl;
	OPEN_FILE_CONN openFile;
	int printcounter = 1, first = 0;

while (lastRecord != -1)
	 { //88ff means no files open on that connection or no other files open
		//0000 means there are files on that connection

		nwrc = (NWScanOpenFilesByConn2(connHandle,theconn,(NWLAST_RECORD NWFAR *)&lastRecord,
			(OPEN_FILE_CONN_CTRL NWFAR *)&openCtrl, (OPEN_FILE_CONN NWFAR *)&openFile));
		if (nwrc == 0x0000)
		  {  if (first == 0)
				 { first = 1;
					printf("\n%s",openFile.fileName);
					fprintf(datafile,"\n%s",openFile.fileName);
				 }
			  else
				 if (printcounter >= 5)
					{  printcounter = 1;
						printf("\n%s",openFile.fileName);
						fprintf(datafile,"\n%s",openFile.fileName);
					}
				 else
					{  printcounter++;
						printf("\t%s",openFile.fileName);
						fprintf(datafile,"\t%s",openFile.fileName);
					}
			  filecounter++;
		  }
	 } //while
} //scanforfiles

//get information on a server
int getserverinfo(servernum)
{  int error = 0;  WORD nwrc;
	VERSION_INFO fsinfotemp;
	static unsigned int servercount;
	NWCONN_HANDLE tempconnHandle;
	int tempconnNumber;

	nwrc = (NWGetConnectionHandle((BYTE NWFAR *)&serverlist[servernum].name, 0,(NWCONN_HANDLE NWFAR *)&tempconnHandle, NULL));
	if (nwrc != 0x0000)
	  {// printf("\nNWGetConnectionHandle failed: %x",nwrc);
		  // getch(); exit(1);
		error = 1;
	  }
	if (error == 0)
	  {
		 nwrc = (NWGetConnectionNumber(tempconnHandle, &tempconnNumber));
		 if (nwrc != 0x0000)
			{  printf("\nNWGetConnectionNumber failed: %x",nwrc);
			   exit(1);
			}

	nwrc = (NWGetFileServerVersionInfo(tempconnHandle, (VERSION_INFO FAR *)&fsinfotemp));
	if (nwrc != 0x0000)
	  { printf("\nNWGetFileServerVersionInfo: failed %04x",nwrc);
		exit(1);
	  }

	strcpy(serverinfo[servercount].name,fsinfotemp.serverName);
	serverinfo[servercount].connsinuse = fsinfotemp.connectionsInUse;
	serverinfo[servercount].yourconnNumber = tempconnNumber;
	serverinfo[servercount].yourconnHandle = tempconnHandle;
	servercount++;
  } //if error
  return(servercount);
} //getserverinfo

//output information gathered from function calls
void outputinfo()
{ int loop;
  struct time t; struct date d;
  char temp[3], TheFileName[15], ServerLog[15], tempfile[15];

// misc. info that is available from some of the nw calls.
/*      printf("\nUser %s on server %s running %d User NetWare v%d.%d",objname, fsinfo.serverName,
	fsinfo.maximumServiceConnections,fsinfo.fileServiceVersion,fsinfo.fileServiceSubVersion);
	printf("\nOn conn. # %d since %02d/%02d/%02d @ %02d:%02d:%02d", connNumber, (int)logintime[1], (int)logintime[2],
	(int)logintime[0],(int)logintime[3],(int)logintime[4],(int)logintime[5]);
	printf("\n%d Users currently on.  Most on at once was: %d", fsinfo.connectionsInUse,
	fsinfo.maxConnectionsEverUsed);
*/
	getdate(&d);
	itoa(d.da_year,tempfile,10);
	itoa(d.da_mon,temp,10);
	strncat(tempfile,temp,2);
	itoa(d.da_day,temp,10);
	strncat(tempfile,temp,2);
	strcpy(ServerLog,tempfile);
	strcpy(TheFileName,tempfile);
	strncat(ServerLog,".SRV",4);
	strncat(TheFileName,".LOG",4);
	if ((datafile = fopen(TheFileName,"a+")) == NULL)
	  {  printf("\nERROR: Cannot open %s",TheFileName);
		 exit(1);
	  }
	else
	  {  if ((datafile2 = fopen(ServerLog,"a+")) == NULL)
		   {  printf("\nERROR: Cannot open %s",ServerLog);
		  exit(1);
		   }
		 else
		   {  gettime(&t);
		  printf("\n%02d/%02d/%02d @ %02d:%02d:%02d",d.da_mon,d.da_day,d.da_year,t.ti_hour,t.ti_min,t.ti_sec);
		  fprintf(datafile,"\n\n%02d/%02d/%02d @ %02d:%02d:%02d",d.da_mon,d.da_day,d.da_year,t.ti_hour,t.ti_min,t.ti_sec);
		  fprintf(datafile2,"\n\n%02d/%02d/%02d @ %02d:%02d:%02d",d.da_mon,d.da_day,d.da_year,t.ti_hour,t.ti_min,t.ti_sec);
		  for (loop=0;loop<serversattached;loop++)
			 {
				connHandle = serverinfo[loop].yourconnHandle;
				filecounter = 0;
				getuserlist(loop);
				printf("\t%003d files open.",filecounter);
				fprintf(datafile,"\t%003d files open.",filecounter);
				fprintf(datafile2,"\t%003d files open.",filecounter);
			 }
		  fclose(datafile);
		  fclose(datafile2);
		 } // else
	  } // else
} // outputinfo

int c_break(void)
{
   clrscr();
   printf("C:\\>");
   getch();
   printf("\n\nUNAUTHORIZED ACCESS has been logged.");
   delay(4);
   return (1);
}